// PGMDesc.cpp : CXgDc̖Oi[
//

#include	"stdafx.h"
#include	"common.h"

#include	"pgmdesc.h"

#define		size_inst	sizeof(_inst)

// 
bool CInst::Init()
{
	_rpti( "Table: Heap Init" );

	pInst = (_inst*)calloc( 128, size_inst );
	if( !pInst )
		return FALSE;
	_rptd();

	nItems = 0;
	return TRUE;
}

// I
void CInst::Exit()
{
	free( pInst );
	_rptt( "Table: Heap Free" );
}

// ǉ
void CInst::AppendItem( int iPGM, int iBank, char *sDesc )
{
	/*	q[ṽTCY:
		128ڂƂɃTCYBȂ킿AnItems128̔{̎A
		TCY(0͏)B

				<1>				<2>						<3>
		nItems				ʓIȏꍇ̍		++nItems	TCY
		-------	---------------	-----------------------	-----------	-----------
		  0		ŏ̍		(GM0: "Grand Piano")	1			128	[127]
		 ..		..				..						..			 |
		127						(GM127: "Gun Shot")		128			 |
		128		̎TCY	(1-0)					129			256	[255]
		129						(1-1)					130			 |
		 ..		..				..						..			 |
		255						(1-127)					256			 |
		256		̎TCY	(2-0)					257			384	[383]
		257						(2-1)					258			 |

	*/

	// <1> TCY
	if( nItems && !(nItems % 128) ) {
		pInst = (_inst*)realloc( pInst, size_inst * (nItems+128) );
	}

	// <2> 
	pInst[nItems].iBank = iBank;
	pInst[nItems].iPGM = iPGM;
	strcpy( pInst[nItems].sDesc, sDesc );

	// <3> CNg
	nItems++;
}


