// WImageList.cpp : C[WXg
//

#include	"stdafx.h"
#include	"resource.h"
#include	"common.h"

#include	"wimagelist.h"

// C[WXg
bool WImageList::Init()
{
	_rpti( "Init: ImageList" );

	// 쐬
	if( !(hImageList = ImageList_Create(16, 16, TRUE, 4, 2)) )
		return FALSE;

	// ACR
	HICON hIcon;
	hIcon = LoadIcon( hInst, MAKEINTRESOURCE(IDI_DEV) ); 
	icnDevice = ImageList_AddIcon( hImageList, hIcon );

	hIcon = LoadIcon( hInst, MAKEINTRESOURCE(IDI_HARDMEM) ); 
	icnHardMem = ImageList_AddIcon( hImageList, hIcon );

	hIcon = LoadIcon( hInst, MAKEINTRESOURCE(IDI_DLL) ); 
	icnDLL = ImageList_AddIcon( hImageList, hIcon );

	hIcon = LoadIcon( hInst, MAKEINTRESOURCE(IDI_SFDEV) ); 
	icnSFDev = ImageList_AddIcon( hImageList, hIcon );

	_rptd();
	return TRUE;
}


// C[WXg̃Zbg(LV)
bool WImageList::SetImageListLV( HWND hwLV )
{
	_rpti( "ImageList: Linking to ListView" );

	if( !ListView_SetImageList(hwLV, hImageList, LVSIL_SMALL) )
		return FALSE;

	_rptd();
	return TRUE;
}


// C[WXg̃Zbg(TV)
bool WImageList::SetImageListTV( HWND hwTV )
{
	_rpti( "ImageList: Linking to TreeView" );

	if( !TreeView_SetImageList(hwTV, hImageList, TVSIL_NORMAL) )
		return FALSE;

	_rptd();
	return TRUE;
}


// C[WXg̃Zbg(CBX)
void WImageList::SetImageListCBX( HWND hwCBX )
{
	SendMessage( hwCBX, CBEM_SETIMAGELIST, 0, (LPARAM)hImageList );
	_rptt( "ImageList: Linked to ComboBoxEx" );
}


