// WTable.cpp : Fe[uǂݍŁAListViewɒǉ
//

#include	"stdafx.h"
#include	"resource.h"
#include	"common.h"

#include	"wndproc.h"

// CEBhEւ̃|C^
extern	WndMain		*pWnd;


/*******	ȉ̓TuXbhŎs	********/

// Thread Local Storage
#define		_TLS	__declspec( thread )

_TLS	CSoundFont	*tls_pSf;
_TLS	HWND		tls_hwPB;
_TLS	HWND		tls_hwLV;

// Fe[uǂݍŁAListViewɒǉ
bool Thread_ListTable::ListTable()
{
	// foCX̏
//	_chkmsg( tls_pSf->DevIsFree(iDeviceID) == SFERR_NOERR), IDS_DEVUSED );	// ?
	_chkmsg( tls_pSf->DevOpen(iDeviceID), IDS_DEVINIT, pWnd->hWnd );

	// progress bar
	pWnd->wStatus.SetMax(
					(bGM?127:0) +
					(bExt?(iEnd - iStart):0) +
					(bDrum?1:0)
					);

	// Jn!!
	int iBank = 0;
	int ib, p=0;
	pWnd->wStatus.TogglePart();
	pWnd->wStatus.SetString( 0, IDS_LOAD );


	// GM
	if( bGM ) {
		int i;
		for( i=0; i<128; i++ ) {
			ListTable_PGM( i, 0, &p );
			_pstm( tls_hwPB, PBM_SETPOS, ++iBank, 0 );
		}
	}

	// GS/XG
	if( bExt ) {
		for( ib = iStart; ib <= iEnd; ib++ ) {
			ListTable_Bank( ib, &p );
			_pstm( tls_hwPB, PBM_SETPOS, ++iBank, 0 );
		}
	}

	// DRUMS
	if( bDrum ) {
		ListTable_Bank( SFMAN_PERCUSSIVE_BANK, &p );
		_pstm( tls_hwPB, PBM_SETPOS, ++iBank, 0 );
	}

	/*	[vI	*/

	// I!!
	pWnd->wStatus.TogglePart();
	pWnd->wStatus.SetString( 0, IDS_RIGHTCLICK );

	// foCX̉
	tls_pSf->DevClose( iDeviceID );
	return TRUE;
}

// oNǂݍ
inline void Thread_ListTable::ListTable_Bank( int iBank, int *iPos )
{
	int i;

	for( i=0; i<128; i++ )
		ListTable_PGM( i, iBank, iPos );
}

// PGMǂݍ
void Thread_ListTable::ListTable_PGM( int iPGM, int iBank, int *iPos )
{
	char sDesc[128], sCom[128+8];
	ZeroMemory( sDesc, sizeof(sDesc) );

	LVITEM it;
	it.mask = LVIF_TEXT;
	it.cchTextMax = sizeof(sCom);
	it.pszText = sCom;

	tls_pSf->GetPresetDesc( iDeviceID, iBank, iPGM, sDesc );
	if( sDesc[0] != NULL ) {
		it.iItem = (int)(*iPos);

		it.iSubItem = 0;
		sprintf( sCom, "%d-%d: %s", iBank, iPGM, sDesc );
		ListView_InsertItem( tls_hwLV, &it );

		it.iSubItem = 1;
		itoa( iPGM, sCom, 10 );
		ListView_SetItem( tls_hwLV, &it );

		it.iSubItem = 2;
		itoa( iBank, sCom, 10 );
		ListView_SetItem( tls_hwLV, &it );

		(int)(*iPos)++;
	}
}

// Xbh
static	bool	bExit;
DWORD WINAPI ThreadListTable( LPVOID )
{
	if( bExit )
		return 0;

	do {
		tls_pSf = pWnd->pSf;
		tls_hwPB = pWnd->wStatus.hwPB;
		tls_hwLV = pWnd->wLV.hwLV;

		pWnd->pTable->ListTable();

		_rptt( "Thread: Suspend" );
		SuspendThread( pWnd->pTable->hThread );
	}
	while( !bExit );

	return 0;
}

/*******	ȉ̓CXbhŎs	*******/

// Xbh
bool Thread_ListTable::Init()
{
	// default value
	iDeviceID = 0;

	iStart = 1;
	iEnd = 127;

	bGM = TRUE;
	bExt = TRUE;
	bDrum = TRUE;

	// thread
	bExit = FALSE;
	_rpti( "Thread: Init" );

	DWORD dwID;
	hThread = CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE)ThreadListTable,
							0, CREATE_SUSPENDED, &dwID );
	_chkapi( hThread );
	_rptd();

	return TRUE;
}

// Xbhs
void Thread_ListTable::ExecuteThread()
{
	_rptt( "Thread: Execute" );
	ResumeThread( hThread );
}

// XbhI
void Thread_ListTable::Exit()
{
	_rptt( "Thread: Exit" );
	bExit = TRUE;
	ResumeThread( hThread );

	WaitForSingleObject( hThread, 1000 );	// S
}


