/////////////////////////////////////////////////////////////////////
//
//	XSoundFont.h - SoundFont Interface Class
//
//	Copyright (C) WanSystem Porject, 2000-2001.
//
//	(Revision 1.00)
//
/////////////////////////////////////////////////////////////////////
#define		__cpp__xsoundfont__		100

//	INCLUDES	/////////////////////////////////////////////////////
#ifndef	_STDAFX_IMP_
	#include	<windows.h>
	#include	<windowsx.h>
	#include	<sfman.h>
#endif	//_STDAFX_IMP_

//	DEFINES		/////////////////////////////////////////////////////

//	CLASS (SoundFont Interface Class)	/////////////////////////////
class CSoundFont
{
protected:
	//	INTERNAL VARS	/////////////////////////////////////////////

	HMODULE			hDLL;		// DLL Handle
	PSFMANL101API	pAPI;		// Pointer to DLL API

public:
	//	FUNCTIONS		/////////////////////////////////////////////

	bool	ILoad();							// Initialize DLL Interface
	bool	IFree();							// Destroy DLL Interface

	bool	DevOpen( int nDevID );				// Open Device
	bool	DevClose( int nDevID );				// Close Device
	int		DevGetNum();						// Get number of devices
	long	DevIsFree( int nDevID );			// Is device free?

	bool	GetDevCaps( int nDevID,	PSFCAPSOBJECT pCaps );
	bool	GetPresetDesc( int nDevID, int iBnk, int iPgm, char *sDesc );

};


/////////////////////////////////////////////////////////////////////
